﻿using System;
using System.Collections.Generic;
using System.Windows;

using DevExpress.Data.Filtering;
using DevExpress.Xpf.Grid;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.gridControl.ItemsSource = new AccountList().GetData();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 테이블 뷰 필터 팝업 보여주기 처리하기 - tableView_ShowFilterPopup(sender, e)

        /// <summary>
        /// 테이블 뷰 필터 팝업 보여주기 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void tableView_ShowFilterPopup(object sender, FilterPopupEventArgs e)
        {
            if(e.Column.FieldName != "RegistrationDate")
            {
                return;
            }

            List<object> list = new List<object>();

            list.Add
            (
                new CustomComboBoxItem()
                {
                    DisplayValue = "(All)",
                    EditValue    = new CustomComboBoxItem()
                }
            );

            list.Add
            (
                new CustomComboBoxItem()
                {
                    DisplayValue = "Registered in 2008",
                    EditValue    = CriteriaOperator.Parse
                    (
                        string.Format
                        (
                            "[RegistrationDate] >= #{0}# AND [RegistrationDate] < #{1}#",
                            new DateTime(2008, 1, 1).ToString("yyyy-MM-dd"),
                            new DateTime(2009, 1, 1).ToString("yyyy-MM-dd")
                        )
                    )
                }
            );

            list.Add
            (
                new CustomComboBoxItem()
                {
                    DisplayValue = "Registered in 2009",
                    EditValue    = CriteriaOperator.Parse
                    (
                        string.Format
                        (
                            "[RegistrationDate] >= #{0}# AND [RegistrationDate] < #{1}#",
                            new DateTime(2009, 1, 1).ToString("yyyy-MM-dd"),
                            new DateTime(2010, 1, 1).ToString("yyyy-MM-dd")
                        )
                    )
                }
            );

            e.ComboBoxEdit.ItemsSource = list;
        }

        #endregion
    }
}